!---------------------------------------------------------------------
program checkoutput
!---------------------------------------------------------------------
! test if output mask deviates by reference mask by more than on pixel
! mask may only contain the values 0 and 1

use dal
use errorhandling

implicit none

integer(kind=int32) :: ix, iy, iix, iiy, sum
type(DataSetT)  :: set1, set2
type(ArrayT)    :: arr1, arr2

integer(kind=int32), dimension(:,:), pointer :: test, ref
logical ok

set1 = dataSet("mask_image.fits", read)
arr1 = array(set1, "PRIMARY",read)

set2 = dataSet("mask_image.ref", read)
arr2 = array(set2, "PRIMARY",read)

test => int32Array2Data(arr1)
ref  => int32Array2Data(arr2)

ok = .true.

do ix=10,310,10
  do iy=10,310,10
    if (test(ix,iy) /= 0 .and. test(ix,iy) /= 1) ok = .false.
    sum = 0 
    do iix=ix-1,ix+1
      do iiy=iy-1,iy+1
        sum = sum+ref(iix,iiy)
      end do
    end do
    if (sum == 9 .and. test(ix,iy) == 0) ok = .false.
    if (sum == 0 .and. test(ix,iy) == 1) ok = .false.
  end do
end do

call release(arr1)
call release(arr2)
call release(set1)
call release(set2)

if (.not.ok) call error("test failed","mask image contains wrong values")

end program checkoutput


